#include <QString>
#include "configuredlg.h"
#include "selectworkdirdlg.h"
#include "ui_configuredlg.h"

ConfigureDlg::ConfigureDlg(QWidget *parent) : QDialog(parent), ui(new Ui::ConfigureDlg)
{
    ui->setupUi(this);
}

ConfigureDlg::~ConfigureDlg()
{
    delete ui;
}


//
// Initialize the dialog box.
//
void ConfigureDlg::InitDialog(app_config *Config)
{
   // Save a pointer to configuration structure,
   // and the contents of the config structure.
   pConfig = Config; DlgConfig = *Config;

   // Initialize all widgets in the dialog box.
   ui->spinBox1->setValue(DlgConfig.TimeInterval);
   ui->OpenLast->setChecked(DlgConfig.AutoLoad);
}




//
// User has pressed the 'OK' button.
//
void ConfigureDlg::accept(void)
{
   // Get values from the dialog box.
   DlgConfig.TimeInterval = ui->spinBox1->value();
   DlgConfig.AutoLoad = ui->OpenLast->isChecked();

   // Return configuration back to parent class.
   *pConfig = DlgConfig;

   // Close the dialog and return 'Accepted' signal.
   QDialog::accept();
}
