#ifndef LIBRARY_H
#define LIBRARY_H

#include "types.h"

// Function prototyping for all functions in 'library.cpp'.
bool IsPreflightCheckOK();
bool IsSfileNameOk(QString);
bool IsOperatorIdentityOK(QString);
void CopyQstrToChar(QString, char*);
void PadString(char*, int);
void PadQString(QString*, int);
void UnPadString(char*, int);
void UnPadQString(QString *string);
void StrDelete(char*, int);
void StrRmvTrailingSpaces(char*);
void TrimSpaces(QString*);
bool IsQStringAllSpace(QString);
void fstrcpy(char*, char*, int);
bool CreatePath(QString);
bool CleanDir(QString);
void PathCdUp(QString*);
void CreateElvTimeStr(db_time*, QString*);
void GetFileModTime(QString, QDateTime*);
QString GetNameFromFilePath(QString);
void ClearCommonBlocks();
void ConvertCatFileToLocalDb(QString, QString, int*, int*);
bool MergeFiles(QStringList, QString);
bool IsDataLineEmpty(char[], qint64);
bool IsFileInPath(QString);
ulong JulianDay(db_time*);
char TimeCmp(db_time*, db_time*);
double TimeDiff(db_time*, db_time*);
int ReadFileLine(QString, int, QString*);
int ReadTextFile(QString, QStringList*);
bool WriteTextFile(QString, QStringList);
#endif // LIBRARY_H
