#include <QtGui/QApplication>
#include "mainwindow.h"
#include "library.h"

int main(int argc, char *argv[])
{
   // The QApplication object must be created before any other
   // objects related to the user interface are created.
   QApplication a(argc, argv, true);

   // Set locale.
   #ifdef Q_OS_LINUX
   QLocale::setDefault(QLocale(QLocale::English, QLocale::UnitedStates));
   #endif

   // Set style sheet for taskbar.
   a.setStyleSheet(QString("QStatusBar::item { border: 0px solid black } "));

   // Do prefilight checking. If check fails, application will quit here.
   if (!IsPreflightCheckOK()) return 1;

   // Reduce font size on linux platform.
   #ifdef Q_OS_LINUX
   QFont AppFont = a.font(); AppFont.setPointSize(8); a.setFont(AppFont);
   #endif

   // Create the main window class and show the window.
   MainWindow w;

   // Show the main window.
   w.show();

   // Enter the main event loop and waits until exit() is called.
   return a.exec();
}
