#include "seteventindicatordlg.h"
#include "ui_seteventindicatordlg.h"
#include "mainwindow.h"
#include "logmodel.h"
#include <QString>

SetEventIndicatorDlg::SetEventIndicatorDlg(db *database, QWidget *parent) : QDialog(parent), ui(new Ui::SetEventIndicatorDlg) {
    ui->setupUi(this);

    // Event type E
    int i=69;
    ui->comboBox->addItem(QString("%1").arg((char)i));
    // Event type P
    i=80;
    ui->comboBox->addItem(QString("%1").arg((char)i));
    // Event type v
    i=86;
    ui->comboBox->addItem(QString("%1").arg((char)i));
    // Event type Q
    i=81;
    ui->comboBox->addItem(QString("%1").arg((char)i));
    // Event type blank
    i=32;
    ui->comboBox->addItem(QString("%1").arg((char)i));

    DataBase=database;

    connect( ui->pushButton_Cancel, SIGNAL( clicked() ), this, SLOT( close() ) );
    connect( ui->pushButton_OK, SIGNAL( clicked() ), this, SLOT( SetEventIndicatorDlg_OK() ) );
}

SetEventIndicatorDlg::~SetEventIndicatorDlg() {
    delete ui;
}

void SetEventIndicatorDlg::SetEventIndicatorDlg_OK() {

    char status;
    QChar EventType;

    // blank [default]
    int ComboChar = 32;

    // Get selection from combo box
    int ComboIndex = ui->comboBox->currentIndex();

    // Event type E
    if (ComboIndex == 0) ComboChar=69;
    // Event type P
    if (ComboIndex == 1) ComboChar=80;
    // Event type V
    if (ComboIndex == 2) ComboChar=86;
    // Event type Q
    if (ComboIndex == 3) ComboChar=81;

    // This may take some time. Show the wait cursor.
    QApplication::setOverrideCursor(Qt::WaitCursor);

    // Replace the event type for all events.
    EventType = (char)ComboChar;
    int NumEvents = DataBase->GetNumberOfEvents();
    event_node_ *Node;
    for (int i=0; i<NumEvents; ++i) {
       Node = DataBase->GetEventByIndex(i);
       Node->hypocenters.first->type=EventType.toAscii();
       if (!DataBase->UpdateSfile(i, &status)) {
          // Unable to write new event file.
          // Write error message to the log.
          Message = "Failed to update model indicator for '";
          Message.append(Node->metadata.sfile); Message.append("'.");
          emit WriteLog(logmodel::error, Message);
       }
    }

    // Restore the cursor.
    QApplication::restoreOverrideCursor();

    // Close the dialog box.
    accept();
}
